Sy.render = function () {
    //cache the last rendered state.
    //if the state changes, or if "state logic" triggers, re-render
    if (Sy.varRENDER_TURN && Sy.varRENDER_STATE) {
        if (Sy.varLastRenderedState != Sy.CurrentState || Sy.varReRenderState) {
            //cache the replacement of text with bitmaps
            var textAdded = false;
            var menuElem = $("#menuElem");
            menuElem.remove();
            var previewElem = $("#previewElem");
            previewElem.remove();
            var selCursorElem = $("#cursorElem");
            if (selCursorElem.length > 0) {
                selCursorElem.offset({
                    top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * (Sy.map.cursorY) - 1,
                    left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * (Sy.map.cursorX) - 1
                });
                selCursorElem.width(19); //Sy.TILE_SIZE-5);
                selCursorElem.height(19); //Sy.TILE_SIZE-5);
            }
            switch (Sy.CurrentState) {
            case Sy.STATE_GAME_OVER:
                {
                    $("#statustable").remove();
                    $("#main").remove();
                    var outcome = "Lose";
                    var check = Sy.checkForWin();
                    if (check.youWin) {
                        outcome = "Win";
                    }
                    $("body").append($("<div style='position:absolute;'><span style='color:white;font-size:24px;font-family:arial'>You " + outcome + "</span> </div>"));
                    textAdded = true;
                    break;
                }
            case Sy.STATE_POST_MOVE_ITEM_MENU:
                {
                    if (Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].displayingItemList == false) {
                        previewElem = $("#previewElem");
                        previewElem.remove();
                        previewElem = $("<div style='position:absolute;'></div>");
                        $("#main").append(previewElem);
                        previewElem.attr("id", "previewElem");
                        var stri = "<table><tr><td><span>" + Sy.internalStateVar[Sy.STATE_POST_MOVE_ITEM_MENU].itemOptions + "</span></td></tr></table>";
                        previewElem.html(stri);
                        previewElem.offset({
                            top: Sy.RENDER_OFFSET_Y + Sy.map.cursorY * Sy.TILE_SIZE + 4,
                            left: Sy.RENDER_OFFSET_X + Sy.map.cursorX * Sy.TILE_SIZE + 24
                        });
                        previewElem.addClass("bluebg");
                    }
                }
            case Sy.STATE_SELECT_STAFF:
            case Sy.STATE_POST_MOVE_MENU:
            case Sy.STATE_SELECT_WEAPON_MENU:
            case Sy.STATE_DISPLAY_MENU:
                {
                    //render the menu
                    menuElem = $("<div style='position:absolute;'></div>");
                    $("#main").append(menuElem);
                    menuElem.attr("id", "menuElem");
                    var stri = "";
                    for (var m = 0; m < Sy.internalStateVar[Sy.CurrentState].menu.length; m += 1) {
                        if (m == Sy.internalStateVar[Sy.CurrentState].selectedOption) {
                            stri += "<img alt='' src='./images//hand.png' style='position:absolute;left:-20px;'/><strong>";
                        }
                        stri += "<span>";
                        stri += Sy.internalStateVar[Sy.CurrentState].menu[m]
                        stri += "</span>";
                        if (m == Sy.internalStateVar[Sy.CurrentState].selectedOption) {
                            stri += "</strong>";
                        }
                        stri += "<br/>";
                    }
                    menuElem.html(stri);
                    menuElem.offset({
                        top: Sy.RENDER_OFFSET_Y + Sy.map.cursorY * Sy.TILE_SIZE + 4,
                        left: Sy.RENDER_OFFSET_X + Sy.map.cursorX * Sy.TILE_SIZE + 4
                    });
                }
                textAdded = true;
                break;
            case Sy.STATE_TRADE:
                {
                    var t = $("<table></table>");
                    $("#main").append(t);
                    t.attr("id", "menuElem");
                    t.css("zIndex", 400);
                    t.css("position", "absolute");
                    t.offset({
                        top: Sy.RENDER_OFFSET_Y,
                        left: Sy.RENDER_OFFSET_X
                    });
                    for (var c = 0; c < 5; c += 1) {
                        var fromItem = Sy.internalStateVar[Sy.STATE_TRADE].fromCh.item[c];
                        var toItem = Sy.internalStateVar[Sy.STATE_TRADE].toCh.item[c];
                        var row = $("<tr></tr>");
                        var fromData = $("<td></td>");
                        if (fromItem.menu_option.length > 0) {
                            var str = fromItem.name;
                            if (c == Sy.internalStateVar[Sy.STATE_TRADE].tradeFromIndex) {
                                str = "<img alt='' src='./images/hand.png' style='position:absolute;left:-20px;'/><span>" + str + "</span>";
                                if (Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex != -1) {
                                    str = "<img alt='' src='./images/hand.png' style='position:absolute;left:-20px;'/><span>" + str + "</span>";
                                }
                            }
                            fromData.html(str);
                        }
                        var toData = $("<td></td>");
                        if (toItem.menu_option.length > 0) {
                            var str = toItem.name;
                            if (c == Sy.internalStateVar[Sy.STATE_TRADE].tradeToIndex) {
                                str = "<strong><span>" + str + "</span></strong>"
                                str += "<img alt='' src='./images/hand.png' style='position:absolute;right:-20px;";
                                str += "-moz-transform:scaleX(-1);";
                                str += "-webkit-transform:scaleX(-1);";
                                str += "-o-transform:scaleX(-1);";
                                str += "transform:scaleX(-1);";
                                str += "filter:fliph;";
                                str += "'/>";
                            }
                            toData.html(str);
                        }
                        t.append(row);
                        row.append(fromData);
                        row.append(toData);
                    }
                    textAdded = true;
                    break;
                }
            case Sy.STATE_DISPLAY_UNITS:
                {
                    var t = $("<table></table>");
                    $("#main").append(t);
                    t.attr("id", "menuElem");
                    var unitsToPreview = Sy.varEnemyCharacters;
                    if (Sy.PLAYER_STATE === Sy.PLAYER) {
                        unitsToPreview = Sy.varPlayerCharacters;
                    }
                    for (var i = 0; i < unitsToPreview.length; i += 1) {
                        var unitData = unitsToPreview[i];
                        if (unitData.currentHp < 1 || unitData.player_state == Sy.NO_PLAYER_STATE) {
                            continue;
                        }
                        var row = $("<tr></tr>");
                        t.append(row);
                        //row.addClass("unittable");
                        var displayedStats = ["cl", "currentHp"];
                        for (var j = 0; j < displayedStats.length; j += 1) {
                            var key = displayedStats[j];
                            var td = $("<td></td>");
                            row.append(td);
                            td.text(String(unitData[key]));
                        }
                    }
                    t.css("zIndex", 400);
                    t.css("position", "absolute");
                    t.offset({
                        top: Sy.RENDER_OFFSET_Y,
                        left: Sy.RENDER_OFFSET_X
                    });
                    textAdded = true;
                    break;
                }
            case Sy.STATE_DISPLAY_STAFF_ANIMATION:
                {
                    break;
                }
            case Sy.STATE_USE_ITEM_ANIMATION:
                {
                    break;
                }
            case Sy.STATE_BATTLE:
                {
                    if (Sy.varLastRenderedState != Sy.STATE_BATTLE) {
                        //do setup of battle screen
                        var battleElem = $("#battleElem");
                        if (!battleElem.length) {
                            battleElem = $("<div style='position:absolute;'></div>");
                            $("#main").append(battleElem);
                            battleElem.attr("id", "battleElem");
                            battleElem.offset({
                                top: Sy.RENDER_OFFSET_Y,
                                left: Sy.RENDER_OFFSET_X
                            });
                            battleElem.width(240);
                            battleElem.height(160);
                            var playerBattleElem = $("<div style='position:absolute;'></div>");
                            battleElem.append(playerBattleElem);
                            playerBattleElem.attr("id", "playerBattleElem");
                            var playerBattleRenderElem = $("<div style='position:absolute;'></div>");
                            playerBattleElem.append(playerBattleRenderElem);
                            playerBattleRenderElem.attr("id", "playerBattleRenderElem");
                            var enemyBattleElem = $("<div style='position:absolute;'></div>");
                            battleElem.append(enemyBattleElem);
                            enemyBattleElem.attr("id", "enemyBattleElem");
                            var enemyBattleRenderElem = $("<div style='position:absolute;'></div>");
                            enemyBattleElem.append(enemyBattleRenderElem);
                            enemyBattleRenderElem.attr("id", "enemyBattleRenderElem");
                            var statsTable = $("<div id='enemyHPNumber'></div><div id='enemyHPBar'></div><div id='playerHPNumber'></div><div id='playerHPBar'></div>");
                            battleElem.append(statsTable);
                            $("#enemyHPNumber").text(String(Sy.internalStateVar[Sy.STATE_BATTLE].enemy.currentHp));
                            $("#playerHPNumber").text(String(Sy.internalStateVar[Sy.STATE_BATTLE].character.currentHp));
                            $("#enemyHPNumber").css({
                                "color": "white",
                                "fontSize": "14px"
                            });
                            $("#playerHPNumber").css({
                                "color": "white",
                                "fontSize": "14px"
                            });
                            $("#enemyHPBar").width(parseInt(Sy.internalStateVar[Sy.STATE_BATTLE].enemy.currentHp, 10) * 4);
                            $("#enemyHPBar").height(6);
                            $("#enemyHPBar").addClass("hpbar");
                            $("#playerHPBar").width(parseInt(Sy.internalStateVar[Sy.STATE_BATTLE].character.currentHp, 10) * 4);
                            $("#playerHPBar").height(6);
                            $("#playerHPBar").addClass("hpbar");
                            $("#enemyHPNumber").offset({
                                left: Sy.RENDER_OFFSET_X + 8,
                                top: Sy.RENDER_OFFSET_Y + 140
                            });
                            $("#playerHPNumber").offset({
                                left: Sy.RENDER_OFFSET_X + 128,
                                top: Sy.RENDER_OFFSET_Y + 140
                            });
                            $("#playerHPBar").offset({
                                left: Sy.RENDER_OFFSET_X + 149,
                                top: Sy.RENDER_OFFSET_Y + 144
                            });
                            $("#enemyHPBar").offset({
                                left: Sy.RENDER_OFFSET_X + 30,
                                top: Sy.RENDER_OFFSET_Y + 144
                            });
                            var preview = Sy.internalStateVar[Sy.STATE_BATTLE].battlePreview;
                            var temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 224, Sy.RENDER_OFFSET_Y + 112, "battleplayerhit", String(preview.player.hit), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "8px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 224, Sy.RENDER_OFFSET_Y + 119, "battleplayerdmg", String(preview.player.damage), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "8px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 224, Sy.RENDER_OFFSET_Y + 127, "battleplayercrit", String(preview.player.crit), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "8px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 25, Sy.RENDER_OFFSET_Y + 112, "battleenemyhit", String(preview.enemy.hit), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "8px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 25, Sy.RENDER_OFFSET_Y + 119, "battleenemydmg", String(preview.enemy.damage), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "8px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 25, Sy.RENDER_OFFSET_Y + 127, "battleenemycrit", String(preview.enemy.crit), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "8px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 47, Sy.RENDER_OFFSET_Y + 122, "battleenemywpn", String(Sy.internalStateVar[Sy.STATE_BATTLE].enemyWeapon.name), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "10px"
                            });
                            temp = Sy.putTextAtPosition(Sy.RENDER_OFFSET_X + 123, Sy.RENDER_OFFSET_Y + 122, "battleplayerwpn", String(Sy.internalStateVar[Sy.STATE_BATTLE].weapon.name), "battleElem");
                            temp.css({
                                "color": "white",
                                "fontSize": "10px"
                            });
                            Sy.internalStateVar[Sy.STATE_BATTLE].frame = 1;
                        }
                    } else {
                        if (!Sy.internalStateVar[Sy.STATE_BATTLE].animationIsOver) {
                            var data = Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack[0];
                            var side = data.side;
                            var weapon = data.weapon;
                            var cl = data.cl;
                            var desc = data.desc.toUpperCase();
                            var missFlag = false;
                            if (desc == "MISS") {
                                missFlag = true;
                                desc = "ATTACK";
                            }
                            var FRAME_RATE = 0.5;
                            var img = $('img[src*="_' + String(cl).toUpperCase() + String(weapon).toUpperCase() + desc + '"]');
                            var enemyImg = $('img[src*="_' + String(data.enemy).toUpperCase() + '"]');
                            if (enemyImg.length > 0) {
                                enemyImg = $(enemyImg[0]);
                            }
                            if (img.length) {
                                var currentFrame = Math.floor(Sy.internalStateVar[Sy.STATE_BATTLE].frame);
                                var src = img.attr("src");
                                var attrs = src.split("_");
                                var removeUrl = attrs[0].split("/");
                                attrs[0] = removeUrl.pop()
                                var frameWidth = parseInt(attrs[0], 10);
                                var frameHeight = parseInt(attrs[1], 10);
                                var totalFrames = parseInt(attrs[2], 10);
                                var battleFrame = parseInt(attrs[3], 10);
                                var enemySrc = enemyImg.attr("src");
                                var enemyAttrs = enemySrc.split("_");
                                removeUrl = enemyAttrs[0].split("/");
                                enemyAttrs[0] = removeUrl.pop()
                                var enemyFrameWidth = parseInt(enemyAttrs[0], 10);
                                var enemyFrameHeight = parseInt(enemyAttrs[1], 10);
                                var enemyTotalFrames = parseInt(enemyAttrs[2], 10);
                                var enemyBattleFrame = parseInt(enemyAttrs[3], 10);
                                var playerBattleElem = $("#enemyBattleElem");
                                var playerBattleRenderElem = $("#enemyBattleRenderElem");
                                var enemyBattleElem = $("#playerBattleElem");
                                var enemyBattleRenderElem = $("#playerBattleRenderElem");
                                var frameOffsetLeft = -1 * frameWidth * totalFrames + frameWidth * currentFrame;
                                var enemyFrameOffsetLeft = 0;
                                var enemyPositionOffset = 64;
                                var positionOffset = 32;
                                var flipImage = "-1";
                                var enemyFlipImage = "1";
                                var playerOffsetTop = 0;
                                var enemyOffsetTop = 0;
                                if (currentFrame == battleFrame + 2) {
                                    var selectString = "player";
                                    if (side == Sy.PLAYER_STATE) {
                                        selectString = "enemy";
                                    }
                                    var damageToDeal = Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage[0];
                                    if (damageToDeal > 0) {
                                        if (Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage[0] > 0) {
                                            $("#" + selectString + "HPBar").width($("#" + selectString + "HPBar").width() - 4);
                                            Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage[0] -= 1;
                                            var dmgText = 0;
                                            var rollingDamage = Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage[0];
                                            if (selectString == "player") {
                                                var tempDmg = Sy.internalStateVar[Sy.STATE_BATTLE].character.currentHp;
                                                if (tempDmg > 0) {
                                                    dmgText = tempDmg;
                                                }
                                            } else {
                                                var tempDmg = Sy.internalStateVar[Sy.STATE_BATTLE].enemy.currentHp;
                                                if (tempDmg > 0) {
                                                    dmgText = tempDmg;
                                                }
                                            }
                                            var roundHPOffset = 0;
                                            if (Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.length > 1) {
                                                for (var remainingAttacks = 1; remainingAttacks < Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.length; remainingAttacks += 1) {
                                                    var tempData = Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack[remainingAttacks];
                                                    if (tempData.side == side) {
                                                        roundHPOffset += Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage[remainingAttacks];
                                                    }
                                                }
                                            }
                                            dmgText += rollingDamage + roundHPOffset;
                                            $("#" + selectString + "HPNumber").text(dmgText);
                                        } else {
                                            Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage[0] = 0;
                                        }
                                        break;
                                    } else {
                                        if (missFlag) {
                                            if ($("#misselem").length == 0) {
                                                var missElem = $("<div style='position:absolute;'></div>");
                                                missElem.attr("id", "misselem");
                                                missElem.width(38);
                                                missElem.height(11);
                                                missElem.css("backgroundImage", "url(./images/battle_miss.png)");
                                                missElem.animate({
                                                    opactity: 0
                                                }, FRAME_RATE * 2000, "linear", function () {
                                                    $(this).remove();
                                                });
                                                missElem.css("zIndex", 999);
                                                if (side == Sy.PLAYER_STATE) {
                                                    playerBattleElem.append(missElem);
                                                    missElem.offset({
                                                        left: Sy.RENDER_OFFSET_X + 64,
                                                        top: Sy.RENDER_OFFSET_Y + 38
                                                    });
                                                } else {
                                                    enemyBattleElem.append(missElem);
                                                    missElem.offset({
                                                        left: Sy.RENDER_OFFSET_X + 128,
                                                        top: Sy.RENDER_OFFSET_Y + 38
                                                    });
                                                }
                                            }
                                        }
                                        Sy.internalStateVar[Sy.STATE_BATTLE].frame = currentFrame + 1;
                                        Sy.internalStateVar[Sy.STATE_BATTLE].battleCalculation.damage.shift();
                                    }
                                }
                                if (frameHeight < 104) {
                                    playerOffsetTop = 104 - frameHeight;
                                }
                                if (enemyFrameHeight < 104) {
                                    enemyOffsetTop = 104 - enemyFrameHeight;
                                }
                                enemyFrameHeight += enemyOffsetTop;
                                frameHeight += playerOffsetTop;
                                if (side == Sy.PLAYER_STATE) {
                                    positionOffset = 64;
                                    enemyPositionOffset = 32;
                                    flipImage = "1";
                                    enemyFlipImage = "-1";
                                    frameOffsetLeft = -1 * currentFrame * frameWidth + frameWidth;
                                    playerBattleElem = $("#playerBattleElem");
                                    playerBattleRenderElem = $("#playerBattleRenderElem");
                                    enemyBattleElem = $("#enemyBattleElem");
                                    enemyBattleRenderElem = $("#enemyBattleRenderElem");
                                    enemyFrameOffsetLeft = -enemyTotalFrames * enemyFrameWidth + enemyFrameWidth;
                                }
                                playerBattleRenderElem.css("zIndex", 900);
                                playerBattleRenderElem.css("background-image", "url(" + src + ")");
                                enemyBattleRenderElem.css("background-image", "url(" + enemySrc + ")");
                                enemyBattleElem.css("background-repeat", "no-repeat");
                                playerBattleElem.css("background-repeat", "no-repeat");
                                enemyBattleElem.offset({
                                    left: Sy.RENDER_OFFSET_X + enemyPositionOffset,
                                    top: Sy.RENDER_OFFSET_Y
                                });
                                enemyBattleElem.width(enemyFrameWidth);
                                enemyBattleElem.height(enemyFrameHeight);
                                enemyBattleElem.css({
                                    "overflow": "hidden"
                                });
                                playerBattleElem.offset({
                                    left: Sy.RENDER_OFFSET_X + positionOffset,
                                    top: Sy.RENDER_OFFSET_Y
                                });
                                playerBattleElem.width(frameWidth);
                                playerBattleElem.height(frameHeight);
                                playerBattleElem.css({
                                    "overflow": "hidden"
                                });
                                playerBattleRenderElem.css({
                                    "position": "relative",
                                    "left": String(frameOffsetLeft) + "px",
                                    "top": String(playerOffsetTop) + "px",
                                    "width": String(frameWidth * totalFrames) + "px",
                                    "height": String(frameHeight) + "px"
                                });
                                if (flipImage == "-1") {
                                    playerBattleRenderElem.css("filter", "fliph");
                                }
                                playerBattleRenderElem.css({
                                    "-moz-transform": "scaleX(" + flipImage + ")",
                                    "-webkit-transform": "scaleX(" + flipImage + ")",
                                    "-o-transform": "scaleX(" + flipImage + ")",
                                    "transform": "scaleX(" + flipImage + ")"
                                });
                                enemyBattleRenderElem.css({
                                    "position": "relative",
                                    "left": String(enemyFrameOffsetLeft) + "px",
                                    "top": String(enemyOffsetTop) + "px",
                                    "width": String(enemyFrameWidth * enemyTotalFrames) + "px",
                                    "height": String(enemyFrameHeight) + "px"
                                });
                                if (enemyFlipImage == "-1") {
                                    enemyBattleRenderElem.css("filter", "fliph");
                                }
                                enemyBattleRenderElem.css({
                                    "-moz-transform": "scaleX(" + enemyFlipImage + ")",
                                    "-webkit-transform": "scaleX(" + enemyFlipImage + ")",
                                    "-o-transform": "scaleX(" + enemyFlipImage + ")",
                                    "transform": "scaleX(" + enemyFlipImage + ")"
                                });
                                //keep rendering
                                if (Sy.internalStateVar[Sy.STATE_BATTLE].frame >= parseInt(attrs[2], 10)) {
                                    Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.shift();
                                    Sy.internalStateVar[Sy.STATE_BATTLE].frame = 0;
                                    if (Sy.internalStateVar[Sy.STATE_BATTLE].battleAnimationStack.length < 1) {
                                        Sy.internalStateVar[Sy.STATE_BATTLE].animationIsOver = true;
                                        $("#battleElem").remove();
                                    }
                                }
                                Sy.internalStateVar[Sy.STATE_BATTLE].frame += FRAME_RATE;
                            }
                        }
                    }
                    textAdded = true;
                    break;
                }
            case Sy.STATE_MOVE_ANIMATION:
                {
                    var path = Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].path;
                    if (path.length > 0) {
                        Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].cursorX = Sy.map.cursorX;
                        Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].cursorY = Sy.map.cursorY;
                        var selectedChX = Sy.internalStateVar[Sy.STATE_IDLE].cursorX;
                        var selectedChY = Sy.internalStateVar[Sy.STATE_IDLE].cursorY;
                        var ch = Sy.getCharacterAtPosition(selectedChX, selectedChY);
                        var chIcon = $("#" + String(Sy.RENDER_OFFSET_X + ch.x * Sy.TILE_SIZE) + "_" + String(Sy.RENDER_OFFSET_Y + ch.y * Sy.TILE_SIZE));
                        if (chIcon.length) {
                            var MOVE_SPEED = 3;
                            var xFrom = parseInt(chIcon.offset().left, 10);
                            var yFrom = parseInt(chIcon.offset().top, 10);
                            var xTo = Sy.RENDER_OFFSET_X + path[path.length - 1][0] * Sy.TILE_SIZE;
                            var yTo = Sy.RENDER_OFFSET_Y + path[path.length - 1][1] * Sy.TILE_SIZE;
                            if (xFrom != xTo || yFrom != yTo) {
                                if (xFrom < xTo) {
                                    if (xTo - xFrom > MOVE_SPEED) {
                                        chIcon.offset({
                                            left: xFrom + (MOVE_SPEED - 1)
                                        });
                                    } else {
                                        chIcon.offset({
                                            left: xTo
                                        });
                                    }
                                    Sy.setImage(chIcon, ch.cl, "right", ch.player_state);
                                }
                                if (xFrom > xTo) {
                                    if (xFrom - xTo > MOVE_SPEED) {
                                        chIcon.offset({
                                            left: xFrom - (MOVE_SPEED - 1)
                                        });
                                    } else {
                                        chIcon.offset({
                                            left: xTo
                                        });
                                    }
                                    Sy.setImage(chIcon, ch.cl, "left", ch.player_state);
                                }
                                if (yFrom < yTo) {
                                    if (yTo - yFrom > MOVE_SPEED) {
                                        chIcon.offset({
                                            top: yFrom + (MOVE_SPEED - 1)
                                        });
                                    } else {
                                        chIcon.offset({
                                            top: yTo
                                        });
                                    }
                                    Sy.setImage(chIcon, ch.cl, "down", ch.player_state);
                                }
                                if (yFrom > yTo) {
                                    if (yFrom - yTo > MOVE_SPEED) {
                                        chIcon.offset({
                                            top: yFrom - (MOVE_SPEED - 1)
                                        });
                                    } else {
                                        chIcon.offset({
                                            top: yTo
                                        });
                                    }
                                    Sy.setImage(chIcon, ch.cl, "up", ch.player_state);
                                }
                            } else {
                                Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].path.pop();
                                if (Sy.internalStateVar[Sy.STATE_MOVE_ANIMATION].path.length == 0) {
                                    //update the icon's id when the animation is over
                                    chIcon.attr("id", String(xTo) + "_" + String(yTo));
                                }
                            }
                        }
                    }
                    break;
                }
            case Sy.STATE_SELECT_WEAPON_TARGET:
                {
                    /*
        |name     |^V  |
        |XX  | hp |  XX|
        |XX  | mt |  XX|
        |XX  |hit |  XX|
        |XX  |crit|  XX|
        |^V       |name|
        <table>
            <tr><td>player_name</td><td colspan="2">player_weaponTriangle</td></tr>
            <tr><td>enemy_hp</td><td>HP</td><td>player_hp</td></tr>
            <tr><td>enemy_mt</td><td>mt</td><td>player_mt</td></tr>
            <tr><td>enemy_hit</td><td>hit</td><td>player_hit</td></tr>
            <tr><td>enemy_crit</td><td>crit</td><td>player_crit</td></tr>
            <tr><td colspan="2">enemy_weaponTriangle</td><td>enemy_name</td></tr>
        </table>
        */
                    previewElem = $("<table></table>");
                    previewElem.attr("id", "previewElem");
                    $("#main").append(previewElem);
                    var ch = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].character;
                    var item = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].weapon;
                    var i = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].enemyIndex;
                    var enemy = Sy.internalStateVar[Sy.STATE_SELECT_WEAPON_TARGET].inRange[i];
                    var eitem = Sy.getFirstUseableWeapon(enemy, ch);
                    var preview = Sy.battlePreview(ch, item, enemy, eitem);
                    var playerRounds = "";
                    var enemyRounds = "";
                    if (preview.player.rounds > 1) {
                        playerRounds = "<span class='rounds'>x" + String(preview.player.rounds) + "</span>";
                    }
                    if (preview.enemy.rounds > 1) {
                        enemyRounds = "<span class='rounds'>x" + String(preview.enemy.rounds) + "</span>";
                    }
                    var previewHTMLString = "";
                    previewHTMLString += "<tr><td class='bluebg'>player</td>";
                    previewHTMLString += "<td colspan='2' class='bluebg'>" + item.name + "</td></tr>";
                    previewHTMLString += "<tr><td class='redbg'>" + enemy.currentHp + "</td><td class='yellowbg'>HP</td><td class='bluebg'>" + ch.currentHp + "</td></tr>";
                    previewHTMLString += "<tr><td class='redbg'><span>" + preview.enemy.damage + "</span><span>" + enemyRounds + "</span></td><td class='yellowbg'>mt</td><td class='bluebg'><span>" + preview.player.damage + "</span><span>" + playerRounds + "</span></td></tr>";
                    previewHTMLString += "<tr><td class='redbg'>" + preview.enemy.hit + "</td><td class='yellowbg'>hit</td><td class='bluebg'>" + preview.player.hit + "</td></tr>";
                    previewHTMLString += "<tr><td class='redbg'>" + preview.enemy.crit + "</td><td class='yellowbg'>crit</td><td class='bluebg'>" + preview.player.crit + "</td></tr>";
                    previewHTMLString += "<tr><td colspan='2' class='redbg'>" + eitem.name + "</td><td class='redbg'>enemy</td></tr>";
                    previewElem.append(previewHTMLString);
                    previewElem.find(".bluebg").css("textAlign", "right");
                    previewElem.find(".redbg").css("textAlign", "left");
                    previewElem.find(".yellowbg").css("textAlign", "center");
                    //swap colours for enemy turn
                    if (Sy.PLAYER_STATE == Sy.ENEMY) {
                        var blue = previewElem.find(".bluebg");
                        var red = previewElem.find(".redbg");
                        blue.removeClass("bluebg");
                        blue.addClass("redbg");
                        red.removeClass("redbg");
                        red.addClass("bluebg");
                    }
                    previewElem.offset({
                        left: Sy.RENDER_OFFSET_X + Sy.map.cursorX * Sy.TILE_SIZE + Sy.TILE_SIZE / 2,
                        top: Sy.RENDER_OFFSET_Y
                    });
                }
            case Sy.STATE_SELECT_STAFF_TARGET:
            case Sy.STATE_SELECT_TRADE_TARGET:
            case Sy.STATE_DISPLAY_TURN:
                {
                    for (var i = 0; i < Sy.map.height; i += 1) {
                        for (var j = 0; j < Sy.map.width; j += 1) {
                            var ch = Sy.getCharacterAtPosition(j, i);
                            if (ch.player_state == Sy.PLAYER_STATE && Sy.map.terrain[j][i].heal > 0) {
                                if (ch.currentHp < ch.hp) {
                                    var healAmount = Math.floor(ch.hp * (Sy.map.terrain[j][i].heal / 100));
                                    var healAnim = $("<div style='position:absolute;'><strong>+" + String(healAmount) + "<strong></div>");
                                    $("#main").append(healAnim);
                                    healAnim.offset({
                                        left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j,
                                        top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i
                                    });
                                    healAnim.css({
                                        "zIndex": 400
                                    });
                                    healAnim.animate({
                                        opacity: 0,
                                        top: "-=10"
                                    },
                                    1000, "linear",

                                    function () {
                                        $(this).remove();
                                    });
                                }
                            }
                        }
                    }
                }
            case Sy.STATE_IDLE:
            case Sy.STATE_DISPLAY_MOVE:
            case Sy.STATE_SELECT_STAFF_DESTINATION:
            default:
                {
                    //render the map
                    if (Sy.varLastRenderedState != Sy.CurrentState || Sy.varReRenderState) {
                        var backMap = $("#backMap");
                        if (!(backMap.length)) { //remove the old map element
                            backMap = $("<div style='position:absolute;'></div>");
                            $("#main").append(backMap);
                            backMap.offset({
                                left: 0,
                                top: 0
                            });
                            backMap.attr("id", "backMap");
                            backMap.offset({
                                top: Sy.RENDER_OFFSET_Y,
                                left: Sy.RENDER_OFFSET_X
                            });
                            for (var i = 0; i < Sy.map.height; i += 1) {
                                //uses run-length encoding to reduce number of divs
                                var rowCell = $("<div style='position:absolute;'></div>");
                                for (var j = 0; j < Sy.map.width; j += 1) {
                                    var terrainName = Sy.map.terrain[j][i].name.toLowerCase();
                                    if (j > 0) {
                                        var prevTerrainName = Sy.map.terrain[j - 1][i].name.toLowerCase();
                                        if (prevTerrainName == terrainName && terrainName == 'plain') {
                                            rowCell.width(rowCell.width() + Sy.TILE_SIZE);
                                        } else {
                                            rowCell = $("<div style='position:absolute;'></div>");
                                            backMap.append(rowCell);
                                            rowCell.offset({
                                                top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i,
                                                left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j
                                            });
                                            rowCell.width(Sy.TILE_SIZE);
                                            rowCell.height(Sy.TILE_SIZE);
                                            Sy.autoTile(rowCell, terrainName, j, i);
                                            //rowCell.addClass(terrainName);
                                        }
                                    } else {
                                        backMap.append(rowCell);
                                        rowCell.offset({
                                            top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i,
                                            left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j
                                        });
                                        rowCell.width(Sy.TILE_SIZE);
                                        rowCell.height(Sy.TILE_SIZE);
                                        rowCell.addClass(terrainName);
                                    }
                                    //Sy.autoTile(cell,terrainName,j,i);
                                }
                            }
                        }
                        var mapElem = $("#mapElem");
                        if (mapElem.length) { //remove the old map element
                            mapElem.remove();
                        }
                        mapElem = $("<div style='position:absolute;'></div>");
                        mapElem.attr("id", "mapElem");
                        mapElem.offset({
                            top: 0,
                            left: 0
                        });
                        var unitsElem = $("#unitsElem");
                        if (unitsElem.length) { //remove the old map element
                            unitsElem.remove();
                        }
                        unitsElem = $("<div style='position:absolute;'></div>");
                        unitsElem.attr("id", "unitsElem");
                        unitsElem.offset({
                            top: 0,
                            left: 0
                        });
                        for (var i = 0; i < Sy.map.height; i += 1) {
                            //uses run-length encoding to reduce number of blue divs
                            var rowCell = $("<div style='position:absolute;'></div>");
                            for (var j = 0; j < Sy.map.width; j += 1) {
                                var ch = Sy.getCharacterAtPosition(j, i);
                                if (ch.player_state != Sy.NO_PLAYER_STATE) {
                                    var icon = $("<img alt='' style='position:absolute;'></img>");
                                    icon.attr("id", String(Sy.RENDER_OFFSET_X + ch.x * Sy.TILE_SIZE) + "_" + String(Sy.RENDER_OFFSET_Y + ch.y * Sy.TILE_SIZE));
                                    unitsElem.append(icon);
                                    icon.width(Sy.TILE_SIZE);
                                    icon.height(Sy.TILE_SIZE);
                                    var status = "idle";
                                    if (ch.hasMoved) {
                                        status = "wait";
                                    }
                                    Sy.setImage(icon, ch.cl, status, ch.player_state);
                                    icon.offset({
                                        top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i,
                                        left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j
                                    });
                                }
                                if (Sy.map.attack[j][i] != 0 && Sy.map.move[j][i] == 0) {
                                    var colourSquare = $("<div style='position:absolute;'></div>");
                                    mapElem.append(colourSquare);
                                    colourSquare.offset({
                                        top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i,
                                        left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j
                                    });
                                    colourSquare.width(Sy.TILE_SIZE);
                                    colourSquare.height(Sy.TILE_SIZE);
                                    colourSquare.addClass(Sy.map.attackSquareColour + "Square");
                                }
                                if (Sy.map.move[j][i] != 0) {
                                    if (j > 0) {
                                        if (Sy.map.move[j - 1][i] != 0) {
                                            rowCell.width(rowCell.width() + Sy.TILE_SIZE);
                                        } else {
                                            rowCell = $("<div style='position:absolute;'></div>");
                                            mapElem.append(rowCell);
                                            rowCell.offset({
                                                top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i,
                                                left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j
                                            });
                                            rowCell.width(Sy.TILE_SIZE);
                                            rowCell.height(Sy.TILE_SIZE);
                                            rowCell.addClass("blueSquare");
                                        }
                                    } else {
                                        mapElem.append(rowCell);
                                        rowCell.offset({
                                            top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * i,
                                            left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * j
                                        });
                                        rowCell.width(Sy.TILE_SIZE);
                                        rowCell.height(Sy.TILE_SIZE);
                                        rowCell.addClass("blueSquare");
                                    }
                                }
                            }
                        }
                        var cursorElem = $("<div style='position:absolute;'></div>");
                        mapElem.append(cursorElem);
                        cursorElem.attr("id", "cursorElem");
                        cursorElem.offset({
                            top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * (Sy.map.cursorY) + 1,
                            left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * (Sy.map.cursorX) + 1
                        });
                        cursorElem.width(Sy.TILE_SIZE - 1);
                        cursorElem.height(Sy.TILE_SIZE - 1);
                        $("#main").append(mapElem);
                        $("#main").append(unitsElem);
                    }
                    selCursorElem = $("#cursorElem");
                    selCursorElem.offset({
                        top: Sy.RENDER_OFFSET_Y + Sy.TILE_SIZE * (Sy.map.cursorY) - 1,
                        left: Sy.RENDER_OFFSET_X + Sy.TILE_SIZE * (Sy.map.cursorX) - 1
                    });
                    selCursorElem.width(19);
                    selCursorElem.height(19);
                    var statusElem = $("#statusElem");
                    statusElem.offset({
                        top: Sy.RENDER_OFFSET_Y,
                        left: Sy.RENDER_OFFSET_X + Sy.map.width * Sy.TILE_SIZE + Sy.STATUS_ELEM_OFFSET_X
                    });
                    var statElemOffsetTop = Sy.RENDER_OFFSET_Y;
                    var statElemOffsetLeft = Sy.RENDER_OFFSET_X + Sy.map.width * Sy.TILE_SIZE + Sy.STATUS_ELEM_OFFSET_X;
                    var stch = Sy.getCharacterAtCursor();
                    if (stch.player_state != Sy.NO_PLAYER_STATE) {
                        textAdded = true;
                        if ($("#stimg").length) {
                            $("#stimg").remove();
                        }
                        var stimg = $("<img alt=''></img>");
                        stimg.attr("id", "stimg");
                        $("#statusElem").append(stimg);
                        Sy.setImage(stimg, stch.cl, "idle", stch.player_state);
                        stimg.offset({
                            left: statElemOffsetLeft + 82,
                            top: statElemOffsetTop + 5
                        });
                        statElemOffsetTop -= 5;
                        var equippedWeapon = Im.none;
                        for (var c = 0; c < 5; c += 1) {
                            var item = stch.item[c];
                            if (item.menu_option == Sy.MENU_ATTACK && stch[item.kind + "_exp"] >= item.rank) {
                                equippedWeapon = item;
                                break;
                            }
                        }
                        //stop text overflowing the box
                        var clname = stch.full_name;
                        if (clname.length > 9) {
                            clname = clname.substr(0, 9);
                        }
                        Sy.putTextAtPosition(statElemOffsetLeft + 175, statElemOffsetTop + 16, "stclass", clname, "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 103, statElemOffsetTop + 37, "stlvl", String(stch.level), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 128, statElemOffsetTop + 37, "stexp", String(stch.exp), "statusElem");
                        if (equippedWeapon.name != "none") {
                            Sy.putTextAtPosition(statElemOffsetLeft + 174, statElemOffsetTop + 34, "statk", String(equippedWeapon.might + stch.str), "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 221, statElemOffsetTop + 34, "stcrit", String(equippedWeapon.crit + Math.floor(stch.skl / 2)), "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 174, statElemOffsetTop + 49, "sthit", String(equippedWeapon.hit + stch.skl + Math.floor(stch.lck / 2)), "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 221, statElemOffsetTop + 49, "stavoid", String(stch.spd * 2 + stch.lck - equippedWeapon.weight), "statusElem");
                            var rangeStrng = String(equippedWeapon.min_range);
                            if (equippedWeapon.max_range > equippedWeapon.min_range) {
                                rangeStrng += "-" + String(equippedWeapon.max_range);
                            }
                            Sy.putTextAtPosition(statElemOffsetLeft + 174, statElemOffsetTop + 65, "strange", rangeStrng, "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 174, statElemOffsetTop + 34, "statk", "--", "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 221, statElemOffsetTop + 34, "stcrit", "--", "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 174, statElemOffsetTop + 51, "sthit", "--", "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 221, statElemOffsetTop + 51, "stavoid", "--", "statusElem");
                            Sy.putTextAtPosition(statElemOffsetLeft + 174, statElemOffsetTop + 66, "strange", "--", "statusElem");
                        }
                        Sy.putTextAtPosition(statElemOffsetLeft + 103, statElemOffsetTop + 66, "stmove", String(stch.mov), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 102, statElemOffsetTop + 48, "sthpcur", String(stch.currentHp), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 128, statElemOffsetTop + 48, "sthpmax", String(stch.hp), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 89, "ststr", String(stch.str), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 105, "stmag", String(stch.mag), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 121, "stskill", String(stch.skl), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 137, "stspeed", String(stch.spd), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 153, "stluck", String(stch.lck), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 169, "stdef", String(stch.def), "statusElem");
                        Sy.putTextAtPosition(statElemOffsetLeft + 36, statElemOffsetTop + 185, "stres", String(stch.res), "statusElem");
                        if (stch.sword_exp > 0) {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 90, "stxswd", String.fromCharCode(70 - Math.floor(stch.sword_exp / 100)), "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 90, "stxswd", "-", "statusElem");
                        }
                        if (stch.lance_exp > 0) {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 107, "stxlan", String.fromCharCode(70 - Math.floor(stch.lance_exp / 100)), "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 107, "stxlan", "-", "statusElem");
                        }
                        if (stch.axe_exp > 0) {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 125, "stxaxe", String.fromCharCode(70 - Math.floor(stch.axe_exp / 100)), "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 125, "stxaxe", "-", "statusElem");
                        }
                        if (stch.tome_exp > 0) {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 160, "stxtome", String.fromCharCode(70 - Math.floor(stch.tome_exp / 100)), "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 160, "stxtome", "-", "statusElem");
                        }
                        if (stch.bow_exp > 0) {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 143, "stxbow", String.fromCharCode(70 - Math.floor(stch.bow_exp / 100)), "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 143, "stxbow", "-", "statusElem");
                        }
                        if (stch.staff_exp > 0) {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 178, "stxstaff", String.fromCharCode(70 - Math.floor(stch.staff_exp / 100)), "statusElem");
                        } else {
                            Sy.putTextAtPosition(statElemOffsetLeft + 91, statElemOffsetTop + 178, "stxstaff", "-", "statusElem");
                        }
                        for (var i = 0; i < 5; i += 1) {
                            if (stch.item[i].name != "none") {
                                Sy.putTextAtPosition(statElemOffsetLeft + 141, statElemOffsetTop + 89 + i * 16, "stitem" + String(i), stch.item[i].name, "statusElem");
                            } else {
                                Sy.putTextAtPosition(statElemOffsetLeft + 141, statElemOffsetTop + 89 + i * 16, "stitem" + String(i), "", "statusElem");
                            }
                        }
                        $("#statusElem > div").each(function () {
                            $(this).css({
                                "color": "white",
                                "fontSize": "14px"
                            });
                        });
                    }
                }
            }
            /*
      TERRAIN
      */
            /*
      $("#stterrain").text(Sy.map.terrain[Sy.map.cursorX][Sy.map.cursorY].name);
      $("#sttdef").text("def:"+String(Sy.map.terrain[Sy.map.cursorX][Sy.map.cursorY].def));
      $("#sttavd").text("avd:"+String(Sy.map.terrain[Sy.map.cursorX][Sy.map.cursorY].avoid));
      $("#stthp").text("hp:"+String(Sy.map.terrain[Sy.map.cursorX][Sy.map.cursorY].heal));

    */
            Sy.varLastRenderedState = Sy.CurrentState;
            Sy.varReRenderState = false;
            if (textAdded) {
                //replace regular text with bitmap fonts
                $("div, span, td").each(function () {
                    if ($(this).children().length == 0) {
                        var str = $(this).text();
                        if (str.length > 0) {
                            var htmlbuilder = "";
                            for (var i = 0; i < str.length; i += 1) {
                                htmlbuilder += "<img alt='' src='./images/" + str.charCodeAt(i);
                                htmlbuilder += ".png' style='position:relative;vertical-align:top;'></img>";
                            }
                            $(this).html(htmlbuilder);
                        }
                    }
                });
            }
        }
    }
};

